## google-authenticator 20110413.68230188bdc7

=== libpam/Makefile ===

# Copyright 2010 Google Inc.
# Author: Markus Gutschke
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

.SUFFIXES: .so

all: google-authenticator pam_google_authenticator.so demo                    \
     pam_google_authenticator_unittest

test: pam_google_authenticator_unittest
	./pam_google_authenticator_unittest

install: all
	@dst=/lib$$([ -d /lib64/security ] && echo 64)/security;              \
	[ -d "$${dst}" ] || dst=/usr/lib;                                     \
	sudo=; if [ $$(id -u) -ne 0 ]; then                                   \
	  echo "You need to be root to install this module.";                 \
	  if [ -x /usr/bin/sudo ]; then                                       \
	    echo "Invoking sudo:";                                            \
	    sudo=sudo;                                                        \
	  else                                                                \
	    exit 1;                                                           \
	  fi;                                                                 \
	fi;                                                                   \
	echo cp pam_google_authenticator.so $${dst};                          \
	tar fc - pam_google_authenticator.so | $${sudo} tar ofxC - $${dst};   \
	                                                                      \
	echo cp google-authenticator /usr/local/bin;                          \
	tar fc - google-authenticator | $${sudo} tar ofxC - /usr/local/bin;   \
	$${sudo} chmod 755 $${dst}/pam_google_authenticator.so                \
	                   /usr/local/bin/google-authenticator

clean:
	$(RM) *.o *.so core google-authenticator demo                         \
	               pam_google_authenticator_unittest

google-authenticator: google-authenticator.o base32.o hmac.o sha1.o
	$(CC) -g $(LDFLAGS) $(shell [ -f /usr/lib/libdl.so ] && echo " -ldl") \
	      -o $@ $+

demo: demo.o pam_google_authenticator_demo.o base32.o hmac.o sha1.o
	$(CC) -g $(LDFLAGS) -rdynamic                                         \
	      $(shell [ -f /usr/lib/libdl.so ] && echo " -ldl") -o $@ $+

pam_google_authenticator_unittest: pam_google_authenticator_unittest.o        \
                                   base32.o hmac.o sha1.o
	$(CC) -g $(LDFLAGS) -rdynamic -lc                                     \
              $(shell [ -f /usr/lib/libdl.so ] && echo " -ldl")               \
              -o $@ $+

pam_google_authenticator.so: base32.o hmac.o sha1.o
pam_google_authenticator_testing.so: base32.o hmac.o sha1.o

pam_google_authenticator.o: pam_google_authenticator.c base32.h hmac.h sha1.h
pam_google_authenticator_demo.o: pam_google_authenticator.c base32.h hmac.h   \
	                         sha1.h
	$(CC) -DDEMO --std=gnu99 -Wall -O2 -g -fPIC -c $(CFLAGS) -o $@ $<
pam_google_authenticator_testing.o: pam_google_authenticator.c base32.h       \
                                    hmac.h sha1.h
	$(CC) -DTESTING --std=gnu99 -Wall -O2 -g -fPIC -c $(CFLAGS) -o $@ $<
pam_google_authenticator_unittest.o: pam_google_authenticator_unittest.c      \
                                     pam_google_authenticator_testing.so      \
                                     base32.h hmac.h sha1.h
google-authenticator.o: google-authenticator.c base32.h hmac.h sha1.h
demo.o: demo.c base32.h hmac.h sha1.h
base32.o: base32.c base32.h
hmac.o: hmac.c hmac.h sha1.h
sha1.o: sha1.c sha1.h

.c.o:
	$(CC) --std=gnu99 -Wall -O2 -g -fPIC -c $(CFLAGS) -o $@ $<
.o.so:
	$(CC) -shared -g $(LDFLAGS) -o $@ $+

=== debian/changelog ===
google-authenticator (20110413.68230188bdc7-1ubuntu1) oneiric; urgency=low

  * Make the build multiarch-friendly to fix FTBFS.

 -- Evan Broder <evan@ebroder.net>  Tue, 31 May 2011 20:30:43 +0200

google-authenticator (20110413.68230188bdc7-1) unstable; urgency=low

  * Upstream update.
  * Added FILEFORMAT and totp.html .
  * debian/copyright now includes hints for The MIT License.

 -- LENART Janos <ocsi@debian.org>  Wed, 13 Apr 2011 08:14:21 +0200

google-authenticator (20110224.2b7e90a4d3-1) unstable; urgency=low

  * Initial release. (Closes: #614660)

 -- LENART Janos <ocsi@debian.org>  Thu, 24 Feb 2011 14:23:47 +0100

=== debian/control ===
Source: google-authenticator
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: LENART Janos <ocsi@debian.org>
Build-Depends: debhelper (>= 7.0.5), libpam-dev
Standards-Version: 3.9.1
Homepage: http://code.google.com/p/google-authenticator/
Vcs-hg: https://google-authenticator.googlecode.com/hg/
Vcs-browser: http://code.google.com/p/google-authenticator/source/browse/

Package: libpam-google-authenticator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqrencode3
Description: Two-step verification
 The Google Authenticator project includes implementations of one-time
 passcode generators for several mobile platforms, as well as a
 pluggable authentication module (PAM). One-time passcodes are generated
 using open standards developed by the Initiative for Open
 Authentication (OATH) (which is unrelated to OAuth).
 .
 These implementations support the HMAC-Based One-time Password (HOTP)
 algorithm specified in RFC 4226 and the Time-based One-time Password
 (TOTP) algorithm currently in draft.

## google-authenticator 20130529

=== libpam/Makefile ===
--- 
+++ 
@@ -14,7 +14,20 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+VERSION := 1.0
+
 .SUFFIXES: .so
+
+ifeq ($(origin CC), default)
+  CC := gcc
+endif
+
+DEF_CFLAGS := $(shell [ `uname` = SunOS ] &&                                  \
+                echo ' -D_POSIX_PTHREAD_SEMANTICS -D_REENTRANT')              \
+              -fvisibility=hidden $(CFLAGS)
+DEF_LDFLAGS := $(shell [ `uname` = SunOS ] && echo ' -mimpure-text') $(LDFLAGS)
+LDL_LDFLAGS := $(shell $(CC) -shared -ldl -xc -o /dev/null /dev/null          \
+                       >/dev/null 2>&1 && echo ' -ldl')
 
 all: google-authenticator pam_google_authenticator.so demo                    \
      pam_google_authenticator_unittest
@@ -22,8 +35,17 @@
 test: pam_google_authenticator_unittest
 	./pam_google_authenticator_unittest
 
+dist: clean all test
+	$(RM) libpam-google-authenticator-$(VERSION)-source.tar.bz2
+	tar jfc libpam-google-authenticator-$(VERSION)-source.tar.bz2         \
+	    --xform="s,^,libpam-google-authenticator-$(VERSION)/,"            \
+	    --owner=root --group=root                                         \
+	    *.c *.h *.html Makefile FILEFORMAT README utc-time
+
 install: all
-	@dst=/lib$$([ -d /lib64/security ] && echo 64)/security;              \
+	@dst="`find /lib*/security /lib*/*/security -maxdepth 1               \
+	            -name pam_unix.so -printf '%H' -quit 2>/dev/null`";       \
+	[ -d "$${dst}" ] || dst=/lib/security;                                \
 	[ -d "$${dst}" ] || dst=/usr/lib;                                     \
 	sudo=; if [ $$(id -u) -ne 0 ]; then                                   \
 	  echo "You need to be root to install this module.";                 \
@@ -44,21 +66,18 @@
 
 clean:
 	$(RM) *.o *.so core google-authenticator demo                         \
-	               pam_google_authenticator_unittest
+	               pam_google_authenticator_unittest                      \
+	               libpam-google-authenticator-*-source.tar.bz2
 
 google-authenticator: google-authenticator.o base32.o hmac.o sha1.o
-	$(CC) -g $(LDFLAGS) $(shell [ -f /usr/lib/libdl.so ] && echo " -ldl") \
-	      -o $@ $+
+	$(CC) -g $(DEF_LDFLAGS) -o $@ $+ $(LDL_LDFLAGS)
 
 demo: demo.o pam_google_authenticator_demo.o base32.o hmac.o sha1.o
-	$(CC) -g $(LDFLAGS) -rdynamic                                         \
-	      $(shell [ -f /usr/lib/libdl.so ] && echo " -ldl") -o $@ $+
+	$(CC) -g $(DEF_LDFLAGS) -rdynamic -o $@ $+ $(LDL_LDFLAGS)
 
 pam_google_authenticator_unittest: pam_google_authenticator_unittest.o        \
                                    base32.o hmac.o sha1.o
-	$(CC) -g $(LDFLAGS) -rdynamic -lc                                     \
-              $(shell [ -f /usr/lib/libdl.so ] && echo " -ldl")               \
-              -o $@ $+
+	$(CC) -g $(DEF_LDFLAGS) -rdynamic -o $@ $+ -lc $(LDL_LDFLAGS)
 
 pam_google_authenticator.so: base32.o hmac.o sha1.o
 pam_google_authenticator_testing.so: base32.o hmac.o sha1.o
@@ -66,10 +85,11 @@
 pam_google_authenticator.o: pam_google_authenticator.c base32.h hmac.h sha1.h
 pam_google_authenticator_demo.o: pam_google_authenticator.c base32.h hmac.h   \
 	                         sha1.h
-	$(CC) -DDEMO --std=gnu99 -Wall -O2 -g -fPIC -c $(CFLAGS) -o $@ $<
+	$(CC) -DDEMO --std=gnu99 -Wall -O2 -g -fPIC -c $(DEF_CFLAGS) -o $@ $<
 pam_google_authenticator_testing.o: pam_google_authenticator.c base32.h       \
                                     hmac.h sha1.h
-	$(CC) -DTESTING --std=gnu99 -Wall -O2 -g -fPIC -c $(CFLAGS) -o $@ $<
+	$(CC) -DTESTING --std=gnu99 -Wall -O2 -g -fPIC -c $(DEF_CFLAGS)       \
+              -o $@ $<
 pam_google_authenticator_unittest.o: pam_google_authenticator_unittest.c      \
                                      pam_google_authenticator_testing.so      \
                                      base32.h hmac.h sha1.h
@@ -80,6 +100,6 @@
 sha1.o: sha1.c sha1.h
 
 .c.o:
-	$(CC) --std=gnu99 -Wall -O2 -g -fPIC -c $(CFLAGS) -o $@ $<
+	$(CC) --std=gnu99 -Wall -O2 -g -fPIC -c $(DEF_CFLAGS) -o $@ $<
 .o.so:
-	$(CC) -shared -g $(LDFLAGS) -o $@ $+
+	$(CC) -shared -g $(DEF_LDFLAGS) -o $@ $+ -lpam

=== debian/changelog ===
google-authenticator (20130529-2) unstable; urgency=low

  * Included README

 -- LENART Janos <ocsi@debian.org>  Mon, 22 Jul 2013 09:58:36 +0100

google-authenticator (20130529-1) unstable; urgency=low

  * Upstream update. (Closes: #660188)

 -- LENART Janos <ocsi@debian.org>  Wed, 29 May 2013 21:34:23 +0100

google-authenticator (20110413.68230188bdc7-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Change build dependencies to list a concrete package (Closes: #638802).
  * Unconditionally link -ldl (since Debian always uses glibc), to fix a
    FTBFS caused by libdl.so moving to multiarch paths (Closes: #628729,
    #629666). Patch from Evan Broder <evan@ebroder.net>.

 -- Geoffrey Thomas <geofft@mit.edu>  Sun, 21 Aug 2011 21:45:15 -0400

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,10 @@
 Source: google-authenticator
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LENART Janos <ocsi@debian.org>
-Build-Depends: debhelper (>= 7.0.5), libpam-dev
-Standards-Version: 3.9.1
+Maintainer: LENART Janos <ocsi@debian.org>
+Build-Depends: debhelper (>= 7.0.5), libpam0g-dev
+Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/google-authenticator/
-Vcs-hg: https://google-authenticator.googlecode.com/hg/
-Vcs-browser: http://code.google.com/p/google-authenticator/source/browse/
 
 Package: libpam-google-authenticator
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@

#get-orig-source:

## google-authenticator 20160607

=== debian/changelog ===
google-authenticator (20160607-1) unstable; urgency=low

  * Upstream update (6d45740)

 -- Janos Lenart <ocsi@debian.org>  Tue, 07 Jun 2016 16:59:57 +0100

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,8 @@
 export DH_VERBOSE=1
 
 %:
-	dh $@
+	dh $@ --sourcedirectory=libpam --with=autoreconf
 
-#get-orig-source:
+override_dh_install: build
+	sed -i "/dependency_libs/ s/'.*'/''/" `find debian/ -name '*.la'`
+	dh_install

## google-authenticator 20170702

=== debian/changelog ===
google-authenticator (20170702-1) unstable; urgency=medium

  * Upstream update (00065df) (Closes: #864187).

 -- Janos Lenart <ocsi@debian.org>  Sun, 02 Jul 2017 11:02:29 +0100

google-authenticator (20160607-2) unstable; urgency=high

  * Moved lib to /lib/x86_64-linux-gnu/security/ (Closes: #827670).
  * Fixed typo in manpage (Closes: #826683).

 -- Janos Lenart <ocsi@debian.org>  Sun, 19 Jun 2016 18:49:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: google-authenticator
 Section: admin
 Priority: optional
-Maintainer: LENART Janos <ocsi@debian.org>
-Build-Depends: debhelper (>= 7.0.5), libpam0g-dev
-Standards-Version: 3.9.4
-Homepage: http://code.google.com/p/google-authenticator/
+Maintainer: Janos Lenart <ocsi@debian.org>
+Build-Depends: debhelper (>= 9.20160403), dh-autoreconf, libpam0g-dev
+Standards-Version: 3.9.8
+Homepage: https://github.com/google/google-authenticator/
 
 Package: libpam-google-authenticator
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,9 @@
 %:
 	dh $@ --sourcedirectory=libpam --with=autoreconf
 
+override_dh_auto_configure:
+	dh_auto_configure -- --libdir=/lib/$(DEB_HOST_MULTIARCH)
+
 override_dh_install: build
 	sed -i "/dependency_libs/ s/'.*'/''/" `find debian/ -name '*.la'`
 	dh_install

## google-authenticator 20191231

=== debian/changelog ===
google-authenticator (20191231-2) unstable; urgency=medium

  * Source only upload.

 -- Janos Lenart <ocsi@debian.org>  Tue, 07 Apr 2020 13:55:07 +0100

google-authenticator (20191231-1) unstable; urgency=medium

  * Upstream release (2c7415d, v1.08) (Closes: #919888).
  * Fixed FTBFS (Closes: #952222).
  * Removed the TOTP debugger (totp.html) due to privacy concerns
    (it loads external resources).

 -- Janos Lenart <ocsi@debian.org>  Sat, 07 Mar 2020 09:53:25 +0000 

google-authenticator (20170702-2) unstable; urgency=medium

  * Updated to use libqrencode4 (Closes: #908929).

 -- Janos Lenart <ocsi@debian.org>  Wed, 26 Sep 2018 16:45:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: admin
 Priority: optional
 Maintainer: Janos Lenart <ocsi@debian.org>
-Build-Depends: debhelper (>= 9.20160403), dh-autoreconf, libpam0g-dev
+Build-Depends: debhelper (>= 9.20160403), libpam0g-dev
 Standards-Version: 3.9.8
 Homepage: https://github.com/google/google-authenticator/
 
 Package: libpam-google-authenticator
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libqrencode3
+Depends: ${shlibs:Depends}, ${misc:Depends}, libqrencode4
 Description: Two-step verification
  The Google Authenticator project includes implementations of one-time
  passcode generators for several mobile platforms, as well as a

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,13 @@
 export DH_VERBOSE=1
 
 %:
-	dh $@ --sourcedirectory=libpam --with=autoreconf
+	dh $@ --with=autoreconf
+
+override_dh_auto_test:
+	env USER=`id -un` dh_auto_test
+
+override_dh_clean:
+	dh_clean build/*
 
 override_dh_auto_configure:
 	dh_auto_configure -- --libdir=/lib/$(DEB_HOST_MULTIARCH)

## google-authenticator 20250213-1.11

=== debian/changelog ===
google-authenticator (20250213-1.11-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ SZ Lin (林上智) ]
  * Import new upstream release (Closes: #1074769)
  * Update VCS and Homepage link
  * Update B-D
  * Move libqrencode4 to "Recommends" instead of "Depends" column
    (Closes: #753774)
  * Add upstream metadata
  * Update copyright format and content
  * Drop unneeded lintian-overrides
  * Set Rules-Requires-Root: no
  * Add an example file
  * Update d/rules
  * Remove unneeded files
  * Remove links which have potential privacy breach

  [ Andreas Tille ]
  * Fix watch file
  * Bump Standards-Version to 4.7.2
  * Separate installation for dh_install and dh_installdocs
  * Do not install to /lib
  * d/rules: providing get-orig-source target prefixing release date in front
    of tag version to avoid using epoch due to lower version number

 -- Andreas Tille <tille@debian.org>  Thu, 14 Aug 2025 14:33:34 +0200

google-authenticator (20191231-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update Homepage field. (Closes: #995245)

  [ Michael Biebl ]
  * Install PAM modules into /usr. (Closes: #1061356)

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 25 May 2024 21:51:09 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,18 @@
 Section: admin
 Priority: optional
 Maintainer: Janos Lenart <ocsi@debian.org>
-Build-Depends: debhelper (>= 9.20160403), libpam0g-dev
-Standards-Version: 3.9.8
-Homepage: https://github.com/google/google-authenticator/
+Build-Depends: debhelper-compat (= 13),
+               libpam0g-dev
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
+Homepage: https://github.com/google/google-authenticator-libpam
+Vcs-Git: https://salsa.debian.org/debian/google-authenticator-libpam.git
+Vcs-Browser: https://salsa.debian.org/debian/google-authenticator-libpam
 
 Package: libpam-google-authenticator
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libqrencode4
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: libqrencode4
 Description: Two-step verification
  The Google Authenticator project includes implementations of one-time
  passcode generators for several mobile platforms, as well as a

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --exclude=.la

override_dh_install:
	find . -name "*.la" -delete
	cd debian && find . -type f \( -name "FILEFORMAT" -o -name "totp.html" -o -name "README.md" \) -delete \
	&& find . -type d -name google-authenticator -delete
	dh_install -X".la"

get-orig-source:
	# Fetch the latest tag from GitHub
	$(eval TAG := $(shell uscan --no-download --dehs | xmllint --xpath 'string(/dehs/upstream-version)' -))
	@if [ -z "$(TAG)" ]; then \
		echo "Error: Could not detect latest tag"; \
		exit 1; \
	fi

	# Get the release date from GitHub API
	$(eval SHA := $(shell curl -s "https://api.github.com/repos/google/google-authenticator-libpam/git/refs/tags/$(TAG)" | jq -r '.object.sha'))
	$(eval RELEASEDATE := $(shell curl -s "https://api.github.com/repos/google/google-authenticator-libpam/git/commits/$(SHA)" | jq -r '.committer.date' | cut -d'T' -f1 | tr -d '-'))
	@if [ -z "$(RELEASEDATE)" ]; then \
		echo "Error: Could not fetch release date for tag $(TAG)"; \
		exit 1; \
	fi

	# Download the tarball
	wget -O google-authenticator-libpam-$(TAG).tar.gz \
		https://github.com/google/google-authenticator-libpam/archive/refs/tags/$(TAG).tar.gz

	# Rename to Debian orig format with date prefix
	mv google-authenticator-libpam-$(TAG).tar.gz \
		../google-authenticator-libpam_$(RELEASEDATE)-$(TAG).orig.tar.gz

	@echo "Successfully created ../google-authenticator-libpam_$(RELEASEDATE)-$(TAG).orig.tar.gz"

=== debian/watch ===
version=4

opts="mode=git,dversionmangle=auto" \
   https://github.com/google/google-authenticator-libpam.git refs/tags/v?@ANY_VERSION@
